pub use serde::{Deserialize, Serialize};

#[derive(Deserialize)]
pub struct AuthorizationRequestQuery {
    pub response_type: String,
    pub client_id: String,
    pub redirect_uri: String,
    pub scope: Option<String>,
    pub state: Option<String>,
}

#[derive(Serialize)]
pub struct AuthorizationResponse<'l> {
    pub response_type: &'l str,
    pub state: Option<&'l str>,
    pub code: Option<&'l str>,
}

/*#[derive(Serialize)]
pub enum AuthorizationResponseErrorType {
    InvalidRequest,
    UnauthorizedClient,
    AccessDenied,
    UnsupportedResponseType,
    InvalidScope,
    ServerError,
    TemporarilyUnavailable,
}*/

/*#[derive(Serialize)]
pub struct AuthorizationResponseError {
    state: Option<String>,
    error: AuthorizationResponseErrorType,
}*/

#[derive(Deserialize)]
pub struct TokenRequestBody {
    pub grant_type: String,
    pub refresh_token: Option<String>,
    pub scope: Option<String>,
    pub redirect_uri: Option<String>,
    pub code: Option<String>,
    pub client_id: Option<String>,

    // direct grant
    pub username: Option<String>,
    pub password: Option<String>,
}

#[derive(Serialize)]
pub struct TokenResponse<'l> {
    pub access_token: &'l str,
    pub token_type: &'l str,
    pub refresh_token: Option<&'l str>,
    pub scope: Option<&'l str>,
}
